/*
    AllegroTetrus - An implementation of the classic game using the Allegro
    library (version 4) and the Allegro Wrapper
    Copyright (C) 2013, Marco Forte

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef	ELLESX_H
#define ELLESX_H
#include "Forme.h"
#include "QuadratoStandard.h"
#include <vector>

using namespace std;

class tetris;
class Ellesx :public Forme  
{
	private:
		QuadratoStandard * quad1;
		QuadratoStandard * quad2;
		QuadratoStandard * quad3;
		QuadratoStandard * quad4;
		bool movimento;
		unsigned pos;	
		int tikcs;
		int cont;
	public:

		Ellesx();
		
		~Ellesx()
		{
			delete quad1;
			delete quad2;
			delete quad3;
			delete quad4;
		}
		virtual void ruotaDx (Matrice Mat);

			virtual void distruggiQuadrati (int Y,int X);

		virtual void scendi (Matrice Mat,int livello);	
		virtual void scendiVeloce(Matrice Mat);
	
		virtual void spostaDx(Matrice Mat);
		virtual void spostaSx(Matrice Mat);
			
		virtual void add(tetris* a);
		
		virtual bool getMovimento()  { return movimento; }
		virtual void setMovimento(bool mov)  { movimento=mov; }
		virtual	vector<Point> getPoint();

		virtual void anteprimaProx ()
		{
			quad1->setLeftTopCorner(Point(550,110));
			quad2->setLeftTopCorner(Point(550,130));
			quad3->setLeftTopCorner(Point(550,150));
			quad4->setLeftTopCorner(Point(530,150));
		}
		virtual void rettifica ()
		{
			quad1->setLeftTopCorner(Point(350,50));
			quad2->setLeftTopCorner(Point(350,70));
			quad3->setLeftTopCorner(Point(350,90));
			quad4->setLeftTopCorner(Point(330,90));
		}
};


#endif
