/*
    AllegroTetrus - An implementation of the classic game using the Allegro
    library (version 4) and the Allegro Wrapper
    Copyright (C) 2013, Marco Forte

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef FORME_H
#define	FORME_H

#include <vector>
using namespace std;
#include "QuadratoStandard.h"
#include "Matrice.h"

class tetris;
class Forme
{
	
public:

	virtual bool getMovimento()=0;
	virtual void setMovimento(bool )=0;
	
	virtual void ruotaDx (Matrice Mat)=0;
//	virtual void ruotaDx ()=0;


	virtual void scendi (Matrice Mat,int livello)=0;
	virtual void scendiVeloce(Matrice Mat)=0;
	
	virtual void distruggiQuadrati (int,int)=0;
	
	virtual void spostaDx(Matrice Mat)=0;
	virtual void spostaSx(Matrice Mat)=0;
	
	virtual void add(tetris*)=0;

	virtual ~Forme(){}
	
	virtual vector<Point> getPoint()=0;

	virtual void anteprimaProx ()=0;
	virtual void rettifica ()=0;
};


#endif
