/*
    AllegroTetrus - An implementation of the classic game using the Allegro
    library (version 4) and the Allegro Wrapper
    Copyright (C) 2013, Marco Forte

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "Rettangolo.h"
#include "tetris.h"

#include <iostream>

using namespace std;

Rettangolo::Rettangolo()
{
	tikcs=0;
	pos=0;
	movimento=true;
	quad1=new QuadratoStandard("quadratoRosso.bmp",Point(350,50));
	quad2=new QuadratoStandard("quadratoRosso.bmp",Point(350,70));
	quad3=new QuadratoStandard("quadratoRosso.bmp",Point(350,90));
	quad4=new QuadratoStandard("quadratoRosso.bmp",Point(350,110));
	cont=0;	
}

void Rettangolo::ruotaDx (Matrice Mat)
{
	vector<Point> necessari;
	//*********************************************SPOSTA IN ORIZZANTALE********************************************
	if (pos%2==0)
	{
		//******************************************CASO SUL BORDO DESTRO***************************************
		if(quad2->getLeftTopCorner().getX()==430)
		{
			this->spostaSx(Mat);
			necessari.push_back(Point(quad1->getLeftTopCorner().getX()+20,quad1->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad2->getLeftTopCorner().getX()+20,quad2->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad2->getLeftTopCorner().getX()-20,quad2->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad3->getLeftTopCorner().getX()-20,quad3->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad3->getLeftTopCorner().getX()-40,quad3->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad4->getLeftTopCorner().getX()-20,quad3->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad4->getLeftTopCorner().getX()-40,quad4->getLeftTopCorner().getY()));
			if(Mat.controlloNecessari (necessari)==true)
			{
				quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX()+20,quad1->getLeftTopCorner().getY()+20));
				quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX()-20,quad3->getLeftTopCorner().getY()-20));	
				quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX()-40,quad4->getLeftTopCorner().getY()-40));
				pos++;
				return;
			}
			else
			{
				this->spostaDx(Mat);
				return;
			}	
		}
		//**********************************CASO SUL BORDO SINISTRO(250)*********************************************
		if(quad2->getLeftTopCorner().getX()==250)
		{
			this->spostaDx(Mat);
			this->spostaDx(Mat);
			if(quad2->getLeftTopCorner().getX()!=290)
			{
				while(quad2->getLeftTopCorner().getX()!=250)
					this->spostaSx(Mat);
				return;
			}
			necessari.push_back(Point(quad1->getLeftTopCorner().getX()+20,quad1->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad2->getLeftTopCorner().getX()+20,quad2->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad2->getLeftTopCorner().getX()-20,quad2->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad3->getLeftTopCorner().getX()-20,quad3->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad3->getLeftTopCorner().getX()-40,quad3->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad4->getLeftTopCorner().getX()-20,quad3->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad4->getLeftTopCorner().getX()-40,quad4->getLeftTopCorner().getY()));
			if(Mat.controlloNecessari (necessari)==true)
			{
				quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX()+20,quad1->getLeftTopCorner().getY()+20));
				quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX()-20,quad3->getLeftTopCorner().getY()-20));	
				quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX()-40,quad4->getLeftTopCorner().getY()-40));
				pos++;
				return;
			}
			else
			{
				this->spostaSx(Mat);
				this->spostaSx(Mat);
				return;
			}	
		}
		
		//**********************************CASO SUL BORDO SINISTRO(270)*********************************************
		if(quad2->getLeftTopCorner().getX()==270)
		{
			this->spostaDx(Mat);
			if(quad2->getLeftTopCorner().getX()!=290)
			{
				while(quad2->getLeftTopCorner().getX()!=270)
					this->spostaSx(Mat);
				return;
			}
			necessari.push_back(Point(quad1->getLeftTopCorner().getX()+20,quad1->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad2->getLeftTopCorner().getX()+20,quad2->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad2->getLeftTopCorner().getX()-20,quad2->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad3->getLeftTopCorner().getX()-20,quad3->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad3->getLeftTopCorner().getX()-40,quad3->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad4->getLeftTopCorner().getX()-20,quad3->getLeftTopCorner().getY()));
			necessari.push_back(Point(quad4->getLeftTopCorner().getX()-40,quad4->getLeftTopCorner().getY()));
			if(Mat.controlloNecessari (necessari)==true)
			{
				quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX()+20,quad1->getLeftTopCorner().getY()+20));
				quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX()-20,quad3->getLeftTopCorner().getY()-20));	
				quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX()-40,quad4->getLeftTopCorner().getY()-40));
				pos++;
				return;
			}
			else
			{
				this->spostaSx(Mat);
				return;
			}	
		}
		
		
		//*************************************CASO NORMALE********************************************
		necessari.push_back(Point(quad1->getLeftTopCorner().getX()+20,quad1->getLeftTopCorner().getY()));
		necessari.push_back(Point(quad2->getLeftTopCorner().getX()+20,quad2->getLeftTopCorner().getY()));
		necessari.push_back(Point(quad2->getLeftTopCorner().getX()-20,quad2->getLeftTopCorner().getY()));
		necessari.push_back(Point(quad3->getLeftTopCorner().getX()-20,quad3->getLeftTopCorner().getY()));
		necessari.push_back(Point(quad3->getLeftTopCorner().getX()-40,quad3->getLeftTopCorner().getY()));
		necessari.push_back(Point(quad4->getLeftTopCorner().getX()-20,quad3->getLeftTopCorner().getY()));
		necessari.push_back(Point(quad4->getLeftTopCorner().getX()-40,quad4->getLeftTopCorner().getY()));
		if(Mat.controlloNecessari (necessari)==true)
		{
			quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX()+20,quad1->getLeftTopCorner().getY()+20));
			quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX()-20,quad3->getLeftTopCorner().getY()-20));	
			quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX()-40,quad4->getLeftTopCorner().getY()-40));
			pos++;
			return;
		}		
	}
	else
	//*********************************************SPOSTA IN VERTICALE********************************************
	if(pos%2==1)
	{
		if(quad2->getLeftTopCorner().getY()<=390)//************LIMITE DI BORDO INFERIORE****************
		{
			//*************************************CASO NORMALE********************************************
			necessari.push_back(Point(quad1->getLeftTopCorner().getX(),quad1->getLeftTopCorner().getY()-20));
			necessari.push_back(Point(quad2->getLeftTopCorner().getX(),quad2->getLeftTopCorner().getY()-20));
			necessari.push_back(Point(quad2->getLeftTopCorner().getX(),quad2->getLeftTopCorner().getY()+40));
			necessari.push_back(Point(quad2->getLeftTopCorner().getX(),quad2->getLeftTopCorner().getY()+60));
			necessari.push_back(Point(quad3->getLeftTopCorner().getX(),quad3->getLeftTopCorner().getY()+40));
			necessari.push_back(Point(quad3->getLeftTopCorner().getX(),quad3->getLeftTopCorner().getY()+60));	
			necessari.push_back(Point(quad4->getLeftTopCorner().getX(),quad4->getLeftTopCorner().getY()+40));	
			necessari.push_back(Point(quad4->getLeftTopCorner().getX(),quad4->getLeftTopCorner().getY()+60));		
			if(Mat.controlloNecessari (necessari)==true)
			{
			quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX()-20,quad1->getLeftTopCorner().getY()-20));
			quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX()+20,quad3->getLeftTopCorner().getY()+20));	
			quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX()+40,quad4->getLeftTopCorner().getY()+40));
			pos++;
			return;
			}
		}
	}
}

void Rettangolo::scendi (Matrice Mat,int livello)
{

	cont++;
	if(cont>=10-livello)
	{
	
		cont=0;
	
	if(Mat.scendi(this->getPoint(),1)==true)
	{
	quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX(),quad1->getLeftTopCorner().getY()+1));
	quad2->setLeftTopCorner(Point(quad2->getLeftTopCorner().getX(),quad2->getLeftTopCorner().getY()+1));
	quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX(),quad3->getLeftTopCorner().getY()+1));	
	quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX(),quad4->getLeftTopCorner().getY()+1));
	}
	else
	{
		tikcs++;
		if(tikcs >= 12)
			movimento=false;
	}
	}
}

void Rettangolo::scendiVeloce(Matrice Mat)
{
	if(Mat.scendi(this->getPoint(),1)==true)
	{
	quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX(),quad1->getLeftTopCorner().getY()+1));
	quad2->setLeftTopCorner(Point(quad2->getLeftTopCorner().getX(),quad2->getLeftTopCorner().getY()+1));
	quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX(),quad3->getLeftTopCorner().getY()+1));	
	quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX(),quad4->getLeftTopCorner().getY()+1));
	}
	else
	{
		tikcs++;
		if(tikcs == 9)
			movimento=false;
	}
	if(Mat.scendi(this->getPoint(),1)==true)
	{
	quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX(),quad1->getLeftTopCorner().getY()+1));
	quad2->setLeftTopCorner(Point(quad2->getLeftTopCorner().getX(),quad2->getLeftTopCorner().getY()+1));
	quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX(),quad3->getLeftTopCorner().getY()+1));	
	quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX(),quad4->getLeftTopCorner().getY()+1));
	}
	else
	{
		tikcs++;
		if(tikcs == 9)
			movimento=false;
	}
}

void Rettangolo::spostaDx(Matrice Mat)
{
	if(Mat.spostaDx2(this->getPoint())==true)
	{
		quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX()+20,quad1->getLeftTopCorner().getY()));
		quad2->setLeftTopCorner(Point(quad2->getLeftTopCorner().getX()+20,quad2->getLeftTopCorner().getY()));
		quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX()+20,quad3->getLeftTopCorner().getY()));	
		quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX()+20,quad4->getLeftTopCorner().getY()));	
	}	
}

void Rettangolo::spostaSx(Matrice Mat)
{
	if(Mat.spostaSx2(this->getPoint())==true)
	{
		quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX()-20,quad1->getLeftTopCorner().getY()));
		quad2->setLeftTopCorner(Point(quad2->getLeftTopCorner().getX()-20,quad2->getLeftTopCorner().getY()));
		quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX()-20,quad3->getLeftTopCorner().getY()));	
		quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX()-20,quad4->getLeftTopCorner().getY()));
	}	
}

void Rettangolo::add(tetris* a) 
{
	a->add(DrawablePointer(*quad1));
	a->add(DrawablePointer(*quad2));	
	a->add(DrawablePointer(*quad3));	
	a->add(DrawablePointer(*quad4));
}


vector<Point> Rettangolo::getPoint()
{

	vector<Point>temp;
	temp.push_back(quad1->getLeftTopCorner());
	temp.push_back(quad2->getLeftTopCorner());
	temp.push_back(quad3->getLeftTopCorner());
	temp.push_back(quad4->getLeftTopCorner());
	return temp;

}


void Rettangolo::distruggiQuadrati (int Y,int X)
{
	if(quad1->getLeftTopCorner().getY()==Y*20+50)
	{	quad1->setDistruggi();
	}
	if(quad2->getLeftTopCorner().getY()==Y*20+50)
	{	quad2->setDistruggi();
	}
	if(quad3->getLeftTopCorner().getY()==Y*20+50)
	{	quad3->setDistruggi();
	}
	if(quad4->getLeftTopCorner().getY()==Y*20+50)
	{	quad4->setDistruggi();
	}
	if(quad1->getLeftTopCorner().getY()<Y*20+50)
	{											 
		quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX(),quad1->getLeftTopCorner().getY()+20));
	}
	if(quad2->getLeftTopCorner().getY()<Y*20+50 )
	{	quad2->setLeftTopCorner(Point(quad2->getLeftTopCorner().getX(),quad2->getLeftTopCorner().getY()+20));
	}	
	if(quad3->getLeftTopCorner().getY()<Y*20+50 )
	{	quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX(),quad3->getLeftTopCorner().getY()+20));
	}	
	if(quad4->getLeftTopCorner().getY()<Y*20+50 )
	{	quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX(),quad4->getLeftTopCorner().getY()+20));
	}
}
