/*
    AllegroTetrus - An implementation of the classic game using the Allegro
    library (version 4) and the Allegro Wrapper
    Copyright (C) 2013, Marco Forte

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "tetris.h"
#include <iostream>
#include <cstdlib>
#include <ctime>
#include<sstream>
#include <cstring>




using namespace std;



tetris::tetris() : 
   lineWav("Line.wav"),
  fermaForma("effetto2.wav"),
  gameover2("gameover1.wav") , 
  backgroundSound("background.wav"),
  punteggioText("Punteggio: 0",Point(60,90),Color(255,255,255)),
  livelloText("Livello: 0",Point(60,120),Color(255,255,255)),
  cont_livelloText("Prossimo livello: 4",Point(60,150),Color(255,255,255))
{
	Sprite *provasfondo =new Sprite("provasfondo22.bmp",Point(0,0));
	add(DrawablePointer(*provasfondo));
	  gameOver =new Sprite("gameover.bmp",Point(140,100));
		
// **********************************CORNICE**************************
	Rectangle *cornice1=new Rectangle(245,45,5,410,Color(0,255,0),true);
	add(DrawablePointer(*cornice1));	
	Rectangle *cornice2=new Rectangle(450,45,5,410,Color(0,255,0),true);
	add(DrawablePointer(*cornice2));	
	Rectangle *cornice3=new Rectangle(245,45,210,5,Color(0,255,0),true);
	add(DrawablePointer(*cornice3));
	Rectangle *cornice4=new Rectangle(245,450,210,5,Color(0,255,0),true);
	add(DrawablePointer(*cornice4));
	
//*********************GRIGLIA VERTICALE******************************
	for(int i=70;i<450;i+=20)
		grigliaO.push_back(new Line(250,i,450,i,Color(0,0,255)));
	for(int i=0;i<grigliaO.size();i++)
		add(DrawablePointer(*grigliaO[i]));
//**********************GRIGLIA ORIZZONTALE*************************
	for(int i=270;i<440;i+=20)
		grigliaV.push_back(new Line(i,50,i,450,Color(0,0,255)));
	for(int i=0;i<grigliaV.size();i++)
		add(DrawablePointer(*grigliaV[i]));
//********************RIQUADRO************************
	add(Text("PROSSIMO: ",Point(500,75),Color(0,255,0)));
	Rectangle * riquadro=new  Rectangle(490,90,120,120,Color(0,255,0),false);
	add(DrawablePointer(*riquadro));
// ************************************************


inizio=true;
numforme=-1;
livello=1;
cont_livello=0;
endGame=false;
punteggio=0;
string prova="livello: ";
pause=false;

 add(DrawablePointer(punteggioText));
 add(DrawablePointer(livelloText));
 add(DrawablePointer(cont_livelloText));
 backgroundSound.setLoop(true);
 backgroundSound.play();
}
 
tetris::~tetris() 
{
	for(int i=0;i<grigliaV.size();i++) 	//*****************
		delete grigliaV[i];		//	ELIMINA 
	for(int i=0;i<grigliaO.size();i++)	//	GRIGLIA
		delete grigliaO[i];		//*****************
}

void tetris::onKeyPressed(const Keyboard& keyboard, int keyCode)
{
	if(endGame==false)
	{

	if(keyCode==(KEY_LEFT))
	{
		forme[numforme-1]->spostaSx(mat);
	}
	if(keyCode==(KEY_RIGHT))
	{
		forme[numforme-1]->spostaDx(mat);
	}
	if(keyCode==(KEY_UP))
	{
		forme[numforme-1]->ruotaDx(mat);
	}
	if(keyCode==(KEY_P))
	{										
		if(pause==false)
		{
			pause=true;
			backgroundSound.stop();
		}
		else
		{
			pause=false;
			backgroundSound.play();
		}
	}
} 
}

void tetris::onTick() 
{
	Allegro::onTick();
	if(getKeyboard().isKeyPressed(KEY_Q)) 
    {
        exit = true;
    }
	if(endGame==true)
	{
		backgroundSound.stop();	
		add(Text("GAME OVER",Point(20,20),Color(100,100,100)));
		add(DrawablePointer(*gameOver));
		
		static int i = 0;
		if(i++ == 0) 
		{
			gameover2.play();
		} 
	}
	else
	{

	if(pause==false)
	{	
	

	if( numforme==-1 || forme[numforme-1]->getMovimento()==false)
	{
		fermaForma.play();
		vector<int> linee;
		linee=mat.controlloLine();
		if(linee.size()!=0)//***********************************LINEA COMPLETATA********************
		{
			int cont=0;
			while(cont<linee.size())
			{

				lineWav.play();
				for(int i=0;i<=numforme-1;i++)
				{
					forme[i]->distruggiQuadrati(linee[cont],i);	
				}
				cont++;
				cont_livello++;
			}
			mat.eliminaLine(linee);
			punteggio+=linee.size()*linee.size()*livello;
			if(cont_livello>=livello*4 && livello <10)
			{
				livello++;
				cont_livello=0;
			}
			

			
		}
		if(mat.controlloEndGame()==true)
			{
				endGame=true;
			}
		mat.nuovaForma();
		if(numforme<1)
		for(int start=0;start<2;start++)
		{
		int num=rand()%7;
		switch(num)
		{
			case 0: 
				forme.push_back(new Quadrato());
				break;
			case 1: 
				forme.push_back(new Rettangolo());
				break;				
			case 2: 
				forme.push_back(new Ellesx());
				break;
			case 3: 
				forme.push_back(new Elledx());
				break;
			case 4: 
				forme.push_back(new T());
				break;
			case 5: 
				forme.push_back(new Zetasx());
				break;
			case 6: 
				forme.push_back(new Zetadx());
				break;
/*			default:
				forme.push_back(new Rettangolo());
				break;
*/		}
		numforme+=1;
		}
		else
		{

		int num=rand()%7;
		switch(num)
		{
			case 0: 
				forme.push_back(new Rettangolo());
				break;
			case 1: 
				forme.push_back(new Quadrato());
				break;				
			case 2: 
				forme.push_back(new Ellesx());
				break;
			case 3: 
				forme.push_back(new Elledx());
				break;
			case 4: 
				forme.push_back(new T());
				break;
			case 5: 
				forme.push_back(new Zetasx());
				break;
			case 6: 
				forme.push_back(new Zetadx());
				break;
/*			default:
				forme.push_back(new Zetadx());
				break;
*/		}

		numforme+=1;
		}
		forme[numforme]->anteprimaProx();			
		forme[numforme]->add(this);
		forme[numforme-1]->rettifica();
		forme[numforme-1]->add(this);

		
	}
//**************************************
	forme[numforme-1]->scendi(mat,livello);

	if(getKeyboard().isKeyPressed(KEY_DOWN)) 
	{
		forme[numforme-1]->scendiVeloce(mat);
	}	
	
	mat.aggiorna(forme[numforme-1]->getPoint(),forme[numforme-1]->getMovimento());
//	mat.stampa();
	}
	}

	stringstream sPunti;
        sPunti << "Punteggio:  " << punteggio;
        punteggioText.setText(sPunti.str());
  
	stringstream sLivello;
        sLivello << "Livello:  " << livello;
        livelloText.setText(sLivello.str());
        
	stringstream sLinee;
	if(livello<10)
	{
        sLinee << "Prossimo livello:  " << livello*4-cont_livello;
        cont_livelloText.setText(sLinee.str());
	}
	else
	{
		sLinee << "Prossimo livello: MAX";
        cont_livelloText.setText(sLinee.str());
	}


    static unsigned D = 0;
    if(++D % 5 == 0) 
    {
        draw();
        D = 0;
    }
    
}


