/*
    AllegroTetrus - An implementation of the classic game using the Allegro
    library (version 4) and the Allegro Wrapper
    Copyright (C) 2013, Marco Forte

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef TETRIS_H
#define TETRIS_H


#include "Allegro.h"

#include "Matrice.h"
#include "Forme.h"
#include "QuadratoStandard.h"

#include "Rettangolo.h"
#include "Quadrato.h"
#include "Elledx.h"
#include "Ellesx.h"
#include "T.h"
#include "Zetadx.h"
#include "Zetasx.h"
//#include"QuadratoS.h"
#include "GameOver.h"

class tetris : public Allegro {
public:
    tetris();
    virtual ~tetris();
    void onKeyPressed(const Keyboard& keyboard, int keyCode);
    void onTick();
 
private:
	vector<Forme*> forme;
	int numforme;
	Matrice mat;
	bool endGame;
	vector<Line*> grigliaV;
	vector<Line*> grigliaO;
	int punteggio;
	Text punteggioText;
	int livello;
	Text livelloText;
	int cont_livello;
	Text cont_livelloText;
	bool inizio;
	GameOver fineGioco;
	SampleSound gameover2;
	SampleSound lineWav;
	SampleSound fermaForma;
	SampleSound backgroundSound;
	bool pause;
	Sprite *gameOver; 


//		QuadratoS *provaQuadratoS;
	//	Sprite *provaSprite;
};

#endif
